import pythoncom
from win32com.server.exception import COMException
import win32com.server.util
import win32com.client.dynamic
import win32gui
import random


class PythonUtilities(object):
    _public_methods_=['IIR2']

    #
    # Use pythoncom.CreateGuid() 2/1/08
    #               
    _reg_clsid_="{25F32489-9E84-4D9F-8AEB-44DC9B528405}"
    _reg_desc_ =   "Utilities for Extending Amibroker AFL"
    _reg_progid_ = "PyAFL"
    _readonly_attrs_ = ['revision']

   # class attributes can be defined and used to transfer values from AFL

    _public_attrs_=['NDepVar','ArrayLen','ProbArray',
                    'X_Open','X_High','X_Low','X_Close',
                    'X_Volume','X_OI','Log']

    Log=""  # Log may be a  string use to pass text to AFL
    
    def IIR2(self,InList,coef0,coef1,coef2):
        # example infinite impulse response filter from Amibroker docs
        #
        self.revision="version 1"
        OutList=[]
##
##        print type(InList),type(coef0)
##        print coef0,coef1,coef2
##        
        InList=list(InList)
        
        if len(InList)==0:
            return OutList
        OutList=InList[0:2]
        for index in range(2,len(InList)):    
            OutList.append(coef0*InList[index]+coef1*InList[index-1]+coef2*InList[index-2])
        OutList.append(0)
        if OutList is None:
            return
        else:
            return OutList
 
    
        
if __name__=='__main__':
    print "Registering COM Server "
    import win32com.server.register
    win32com.server.register.UseCommandLine(PythonUtilities)

# uncomment out if you want to unregister com server 

##    from win32com.server.register import UnregisterServer
##    UnregisterServer(PythonUtilities._reg_clsid_)
##    print "Com server unregistered."    

#############################################End Python Code
####################################